{ AD9850 DDS control program (c) by Peter Halicky, OM3CPH

  LPT data bits:
                    _________________
D3 (8)     Enable _|                 |_
                               _
D2 (4)     FQ_UD       _______| |__
                          _
D1 (2)     W_CLK       __| |__
                         __
D0 (1)     DATA        _|  |__
}
Program DDS_Generator;
Uses
  DOS,Crt;
Const
  Two30   = 1073741824;

  CopyRight  = ' AD9850 DDS control programme by (C) OM3CPH, 1998 ';

  Esc  =27;    Enter=13;

  RCal : Array [1..14] Of String[26]=(
  'Ŀ',
  ' Ŀ ĿĿĿ ',
  ' 87.654.321 789 ',
  '   ',
  ' ĿĿĿĿĿĿ ',
  ' UpPgUpC456 ',
  '  ',
  ' ĿĿĿĿĿĿ ',
  ' DnPgDn0123 ',
  '  ',
  ' Ŀ ',
  '         ENTER        ',
  '  ',
  '');

Var
  Buffer              : Array [1..40] Of Byte;

  CLKIN,ENum          : LongInt;

  VideoAddr,PortAddr,
  A,B,C,I,J,K,L       : Word;

  Tc,Tb,ETc,ETb,W,Col,
  RiCalc,NCode,X,Y,Len: Byte;

  ErrCode             : Integer;

  S,CfgName,OneLine,
  StrNumber,PomStr    : String;

  Character           : Char;

  First,Mono          : Boolean;

  DirInfo             : SearchRec;

  Config              : Text;

  R                   : Real;

{ -------------------------------------------------------------------- }

Procedure SetTextMode(Var VideoSeg: Word;Var LineLen : Byte;Var BW: Boolean);
Var
   Reg          : Registers;
   VideoMode    : Byte;
Begin
  With Reg Do
    Begin
      AH:=$0F;
      Intr($10,Reg);
      VideoMode:=Byte(AL And 127);
      LineLen:=AH;
      If VideoMode=7 Then VideoSeg:=$B000
      Else
        Begin
          If VideoMode>3 Then
            Begin
              AH:=0;AL:=3;Intr($10,Reg);
              VideoMode:=3;
            End;
          VideoSeg:=$B800;
        End;
      BW:=VideoMode In [0,2,7];
      AH:=5;
      AL:=0;
      Intr($10,Reg);
    End;
End;

{ --------------------- PaintRec ----------------------------- }

Procedure PaintRect(FromX,FromY,ToX,ToY,TextCol,BacgCol:Byte;Filling:Char);
Var  Horizontal,Vertical   : Word;
Begin
  SetTextMode(VideoAddr,Len,Mono);
  For Vertical:=FromY To ToY Do
    For Horizontal:=FromX to ToX Do
      Begin
        Mem[VideoAddr:(80*Vertical+Horizontal-81)*2  ]:=Ord(Filling);
        Mem[VideoAddr:(80*Vertical+Horizontal-81)*2+1]:=16*BacgCol+TextCol;
      End;
End;

{ -------------------------- Frame --------------------------------- }

Procedure Frame(X1,Y1,X2,Y2,TextCol,BacgCol: Byte;Single: Boolean);
Const
  TabC: Array [1..12] Of Byte=
        (218,191,179,217,196,192,201,187,186,188,205,200);
Begin
  SetTextMode(VideoAddr,Len,Mono);
  If Single Then K:=1 Else K:=7;
  Col:=16*BacgCol+TextCol;
  A:=(80*Y1+X1-81)*2;
  B:=(80*Y2+X1-81)*2;
  C:=A+160;
  Mem[VideoAddr:A  ]:=TabC[K];Mem[VideoAddr:B  ]:=TabC[K+5];
  Mem[VideoAddr:A+1]:=Col;    Mem[VideoAddr:B+1]:=Col;
  Inc(A,2);Inc(B,2);W:=TabC[K+4];
  For I:=X1+1 To X2-1 Do
    Begin
       Mem[VideoAddr:A  ]:=W;  Mem[VideoAddr:B  ]:=W;
       Mem[VideoAddr:A+1]:=Col;Mem[VideoAddr:B+1]:=Col;Inc(A,2);Inc(B,2);
    End;
  Mem[VideoAddr:A  ]:=TabC[K+1];Mem[VideoAddr:B  ]:=TabC[K+3];
  Mem[VideoAddr:A+1]:=Col;      Mem[VideoAddr:B+1]:=Col;
  A:=C;C:=C+(X2-X1) Shl 1;W:=Tabc[K+2];
  For I:=Y1+1 To Y2-1 Do
    Begin
      Mem[VideoAddr:A  ]:=W;  Mem[VideoAddr:C]:=W;
      Mem[VideoAddr:A+1]:=Col;Mem[VideoAddr:C+1]:=Col;Inc(A,160);Inc(C,160);
    End;
End;

{ -----------------------------  Shadow --------------------------------- }

Procedure Shadow(X1,Y1,X2,Y2: Byte);
Begin
  SetTextMode(VideoAddr,Len,Mono);
  If ((X2<78) And (Y2<24)) Then
    Begin
       A:=(80*Y1+X2) Shl 1 + 1;
       For I:=Y1+1 To Y2+1 Do
         Begin
           Mem[VideoAddr:A  ]:=LightGray;
           Mem[VideoAddr:A+2]:=LightGray;Inc(A,160)
       End;
       A:=(80*Y2+X1+2) Shl 1 + 1;
       For I:=X1 To X2-1 Do
         Begin Mem[VideoAddr:A]:=LightGray;Inc(A,2) End;
    End;
End;

{ ----------------------- Curs Off ------------------------ }

Procedure CursOff;
Var Rg    : Registers;
Begin With Rg Do Begin AH:=2;BH:=0;DL:=0;DH:=25;Intr($10,Rg) End;End;

{ ----------------------- Clear Table ------------------------ }

Procedure ClearTable(T,B: Byte);
Begin
  TextColor(T);TextBackGround(B);Window(1,1,80,25);
  PaintRect(1,1,80,25,15,7,Chr(176));
  Frame(1,1,80,25,15,B,False);
  TextColor(0);TextBackGround(7);
  GoToXY(40-(Length(CopyRight) Div 2),1);Write(CopyRight);CursOff;
End;

{ ----------------------------------------------------------------------- }

Procedure SendResult(ReadNumber : LongInt);
Var
  Phase,Result  : LongInt;
Begin
  For I:=1 To 40 Do Buffer[I]:=0;
{ (Fout*2E32)   Div CLKIN   =Phase
  (Fout*2E30*4) Div CLKIN   =Phase
  Fout*(2E30    Div CLKIN)*4=Phase
  Two30 : LongInt =1073741824;
  Two32           =4294967296  - is more than Max LongInt...
  Two32=4*Two30...                                   }
  R:=Two30/CLKIN;
  Phase:=Round(ReadNumber*4*R);
  K:=1;
  Repeat
    Buffer[K]:=Phase Mod 2;Result:=Phase Div 2;
    Inc(K);Phase:=Result;
  Until Result=0;
(**
  Assign(Config,'result1.txt');Rewrite(Config);
  For K:=1 To 40 Do WriteLn(Config,Buffer[K]);Close(Config);
**)
  Port[PortAddr]:=8;Delay(1);
  For I:=1 To 40 Do
    Begin
      Port[PortAddr]:=Buffer[I]+8;  Delay(1);
      Port[PortAddr]:=Buffer[I]+8+2;Delay(1);
    End;
  Port[PortAddr]:=Buffer[I]+8+4;Delay(1);
  Port[PortAddr]:=0;
  Sound(440);Delay(1);NoSound;
End;

{ ------------------------------------------------------------------ }

Procedure Click(Key: Char);
Begin
  TextColor(ETc);TextBackGround(ETb);
  Case Key Of
  #13: Begin GotoXY(x+11,y+11);Write('ENTER');CursOff;Delay(100);
         TextColor(Tc);TextBackGround(Tb);GotoXY(x+11,y+11);Write('ENTER');End;
   '0': Begin GotoXY(x+13,y+8);Write('0');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+13,y+8);Write('0');End;
   '1': Begin GotoXY(x+16,y+8);Write('1');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+16,y+8);Write('1');End;
   '2': Begin GotoXY(x+19,y+8);Write('2');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+19,y+8);Write('2');End;
   '3': Begin GotoXY(x+22,y+8);Write('3');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+22,y+8);Write('3');End;
   '4': Begin GotoXY(x+16,y+5);Write('4');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+16,y+5);Write('4');End;
   '5': Begin GotoXY(x+19,y+5);Write('5');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+19,y+5);Write('5');End;
   '6': Begin GotoXY(x+22,y+5);Write('6');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+22,y+5);Write('6');End;
   '7': Begin GotoXY(x+16,y+2);Write('7');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+16,y+2);Write('7');End;
   '8': Begin GotoXY(x+19,y+2);Write('8');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+19,y+2);Write('8');End;
   '9': Begin GotoXY(x+22,y+2);Write('9');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+22,y+2);Write('9');End;
'c','C': Begin GotoXY(x+13,y+5);Write('C');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+13,y+5);Write('C');End;
{Up}'H': Begin GotoXY(x+ 3,y+5);Write('Up');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+ 3,y+5);Write('Up');End;
{Dn}'P': Begin GotoXY(x+ 3,y+8);Write('Dn');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+ 3,y+8);Write('Dn');End;
{PU}'I': Begin GotoXY(x+ 7,y+5);Write('PgUp');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+ 7,y+5);Write('PgUp');End;
{PD}'Q': Begin GotoXY(x+ 7,y+8);Write('PgDn');CursOff;Delay(100);
          TextColor(Tc);TextBackGround(Tb);GotoXY(x+ 7,y+8);Write('PgDn');End;
  End; { End Case. }
  TextColor(Tc);TextBackground(Tb);
End;

{ ------------------------------------------------------------------ }

Function GiveKey: Char;
Var    OneChar: Char;
Begin
  Repeat
    CursOff;
    OneChar:=ReadKey;
    If OneChar=#0 Then OneChar:=ReadKey;
  Until (Ord(OneChar) In [Enter,Esc,48..57,67,99,72,73,80,81]);
  GiveKey:=OneChar;      {ENTER,ESc,0..9,c,C,Up,PgUp,Dn,PgDn}
End;

{ ------------------------------------------------------------------ }

Begin
  CfgName:='dds.cfg';FindFirst(CfgName,AnyFile,DirInfo);
  If DosError<>0 Then
    Begin WriteLn('Configuration File is missing...');Halt;End;
  Assign(Config,CfgName);Reset(Config);
  For I:=1 To 4 Do
    Begin
      Readln(Config,OneLine);S:=Copy(OneLine,Pos('=',OneLine)+1,2);
      Val(S,J,ErrCode);
      Case I Of 1: ETc:=J;2: ETb:=J;3: Tc :=J;4: Tb :=J;End;
    End;
  Readln(Config,OneLine);
  OneLine:=Copy(OneLine,Pos('=',OneLine)+1,Length(OneLine)-Pos('=',OneLine));
  Val(OneLine,CLKIN,ErrCode);Readln(Config,OneLine);
  OneLine:=Copy(OneLine,Pos('=',OneLine)+1,Length(OneLine)-Pos('=',OneLine));
  Val(OneLine,PortAddr,ErrCode);Close(Config);
  ClrScr;For I:=1 To 40 Do Buffer[I]:=0;
  TextColor(Tc);TextBackGround(Tb);Window(1,1,80,25);
  PaintRect(1,1,80,25,15,7,Chr(176));Frame(1,1,80,25,15,Tb,False);
  TextColor(0);TextBackGround(7);
  GoToXY(40-(Length(CopyRight) Div 2),1);Write(CopyRight);CursOff;
  X:=27;Y:=7;TextColor(Tc);TextBackGround(Tb);StrNumber:='0';
  For RiCalc:=1 To 14 Do Begin GotoXY(X,Y-1+RiCalc);Write(RCal[RiCalc]);End;
  Shadow(X-1,Y,X+25,Y+13);First:=True;Character:=' ';
  Repeat
    If First Then
      Begin                                                      {87.654.321}
        TextColor(ETc);TextBackGround(ETb);GotoXY(X+3,Y+2);Write('         0');
        First:=False;TextColor(Tc);TextBackGround(Tb);
      End
    Else
      Begin
        Character:=GiveKey;Click(Character);
        Val(StrNumber,ENum,ErrCode);
        If ((ENum=0) Or (ENum>(CLKIN Div 3))) Then ENum:=0;
        Case Character Of
          #13 : Begin
                  Val(StrNumber,ENum,ErrCode);
                  If ENum>0 Then SendResult(ENum);
                End;
      '0'..'9': Begin
                  If StrNumber='0' Then StrNumber:=Character
                  Else StrNumber:=StrNumber+Character;
                  If Length(StrNumber)>8 Then StrNumber:=Copy(StrNumber,2,8);
                  Val(StrNumber,ENum,ErrCode);
                End;
       'c','C': ENum:=0;
{Up}       'H': Begin
                  Val(StrNumber,ENum,ErrCode);
                  If (ENum+10)<(CLKIN Div 3) Then Inc(ENum,10);
                End;
{Dn}       'P': Begin
                  Val(StrNumber,ENum,ErrCode);
                  If (ENum-10)>0 Then Dec(ENum,10) Else ENum:=0;
                End;
{PU}       'I': Begin
                  Val(StrNumber,ENum,ErrCode);
                  If (ENum+10000)<(CLKIN Div 3) Then Inc(ENum,10000);
                End;
{PD}       'Q': Begin
                  Val(StrNumber,ENum,ErrCode);
                  If (ENum-10000)>0 Then Dec(ENum,10000) Else ENum:=0;
                End;
        End;{ End Case. }
        Str(ENum,StrNumber);
        If ENum=0 Then PomStr:='         0'
        Else
          Begin
            PomStr:='';J:=0;
            For I:=Length(StrNumber) DownTo 1 Do
              Begin
                PomStr:=StrNumber[I]+PomStr;Inc(J);
                If (J Mod 3)=0 Then PomStr:='.'+PomStr;
              End;
          End;
        While Length(PomStr)<10 Do PomStr:=' '+PomStr;
        TextColor(ETc);TextBackGround(ETb);GotoXY(X+3,Y+2);Write(PomStr);
        TextColor(Tc);TextBackGround(Tb);
        If Character In ['H','P','I','Q'] Then
          Begin
            Val(StrNumber,ENum,ErrCode);
            If ENum>0 Then SendResult(ENum);
          End;
      End;
  Until Ord(Character)=Esc;
  TextColor(7);TextBackGround(0);ClrScr;
End.